/* Foo.c - Copyright (c) Fooey */

#include "qu.h"


/*) module Foo
	...
*/


/*============================================================================

	module functions

============================================================================*/

/*) sub boo (x: Integer) -> Integer
	...
*/
static qu_integer Foo_boo (qu_integer xx)
{
	long x;

	QU_ARG_long (xx, x);
	...

	return QuInteger1;
}



/*============================================================================

	class Foo

============================================================================*/

/*) class Foo
	The non-final Foo class.

	...
	...
*/
static qu_class FooClass;



/*
	The Foo instance struct.
*/
typedef struct TFoo TFoo;
struct TFoo
{
	QU_OBJECT_HEAD;
	qu_string   name;    /* my name */
	char       *buffer;  /* buffer allocated w/ qu_mem_alloc */
	...
};
typedef TFoo *Foo;



/*
	Whether or not x is a Foo
*/
#define FooIs(x) qu_object_instof ((x), FooClass)



/*----------------------------------------------------------------------------
	allocation

	Remember to keep the allocation stuffs in one place.
	If you keep them all over the place then you are asking for trouble.

----------------------------------------------------------------------------*/

static Foo Foo__alloc (qu_class self, qu_string name, long bufsiz)
{
	Foo o;

	assert (self->size <= FooClass->size);
	assert (n > 0);

	QU_MEM_CHECK (n <= QU_MEM_MAX);

	o          = qu_gc_new (FooClass);
	o->name    = name;
	o->bufffer = qu_mem_alloc (bufsiz);
	...
	return o;
}



/*----------------------------------------------------------------------------
	standard class methods
----------------------------------------------------------------------------*/

/*) sub class __inst (x: String) -> Foo
	...
*/
static Foo Foo__inst (qu_class self, qu_string x)
{
	...
}



/*) sub class new (x: String) -> Foo
	...
*/
static Foo Foo_new (qu_class self, qu_string x)
{
	...
}



/*----------------------------------------------------------------------------
	specific class methods
----------------------------------------------------------------------------*/

/*) sub class dang (a: String, b: Integer) -> Boolean
	...
*/
static qu_boolean Foo_dang (qu_class self, qu_string a, qu_integer bb)
{
	long b;

	QU_ARG_TYPE (a, qu_string);
	QU_ARG_long (bb, b);

	...
}



/*----------------------------------------------------------------------------
	low-level instance methods
----------------------------------------------------------------------------*/

static void Foo__destroy (Foo self)
{
	qu_mem_free (self->mem);
	...
}



static void Foo__mark (Foo self)
{
	qu_gc_mark (self->bar);
	...
}



/*----------------------------------------------------------------------------
	standard instance methods
----------------------------------------------------------------------------*/

/*) sub __print -> Null */
static qu_null Foo__print (Foo self)
{
	QU_ENSURE (qu_sys_printz ("<a Foo>", 7));
	return QuNil;
}



/*) sub __string -> String */
static qu_string Foo__string (Foo self)
{
	return qu_string_newz ("<a Foo>");
}



/*----------------------------------------------------------------------------
	specific instance methods
----------------------------------------------------------------------------*/

/*) sub bar (*arg) -> Boolean
	...
*/
static qu_boolean Foo_bar (Foo self, int argc, Any *argv)
{
	unsigned int v = 0;

	QU_ARG_VCOUNT (0, 1);
	if (argc > 0)
		QU_ARG_uint (1, v);

	...

	return QuTrue;
}



/*) sub baz (s:String, i:Int) -> self
	...
*/
static Foo Foo_baz (Foo self, qu_string s, qu_int ii)
{
	long i;

	QU_ARG_TYPE (s, qu_string);
	QU_ARG_long (ii, i);
	...
	return self;
}



/*============================================================================

	init

============================================================================*/

int qu_Foo_init (qu_module m)
{
	/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		module functions
	- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

	qu_module_add_function (m, "boo", Foo_boo, 1);


	/*- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
		class Foo
	- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */

	FooClass = qu_class_newz (m, "Foo", TFoo, Foo__destroy, Foo__mark);

	/* standard class methods */
	qu_class_method_class  (FooClass, QU_NAME__inst, Foo__inst, 1);
	qu_class_method_class  (FooClass, QU_NAME_new  , Foo_new  , 1);

	/* specific class methods */
	qu_class_method_classz (FooClass, "dang" , Foo_dang, 2);

	/* standard isntance methods */
	qu_class_method_inst   (Class, QU_NAME__print , Foo__print , 0);
	qu_class_method_inst   (Class, QU_NAME__string, Foo__string, 0);

	/* specific instance methods */
	qu_class_method_instz  (FooClass, "bar", Foo_bar, -1);
	qu_class_method_instz  (FooClass, "baz", Foo_baz,  2);

	return 1;
}
