/* Boolean.h - Copyright (c) Marc Krisnanto */

#ifndef _H_qu_boolean_
#define _H_qu_boolean_ 1


/** Boolean qu_boolean
	The final Boolean class.

	qu_boolean represents an instance of the Boolean class.
	It is either QuTrue or QuFalse.
*/
extern qu_class QuBooleanClass;


/** QuTrue QuFalse
	These are the only two instances of the Boolean class.

	They are the keywords true and false in program level.
*/
extern qu_boolean QuTrue;
extern qu_boolean QuFalse;


/** qu_boolean_is
	Whether or not an object is a Boolean.
*/
#define qu_boolean_is(x) ((qu_boolean) (x) == QuTrue || (qu_boolean) (x) == QuFalse)


/** QuTrueSTR QuFalseSTR
	The String representation of true and false.
*/
extern qu_string QuTrueSTR;
extern qu_string QuFalseSTR;


/***/
/*--------------------------------------------------------------------------*/

/* called internally by Class to initialize the class */
extern void qu_boolean__setup ();
extern void qu_boolean__init  ();

#endif /*_H_qu_boolean_*/
