/* Compile.h - Copyright (c) Marc Krisnanto */

#ifndef _H_qu_compile_
#define _H_qu_compile_ 1


/** QU_COMPILE_MAXLEVEL QU_COMPILE_MAXDEPTH QU_COMPILE_MAXARGS
	Some reasonable limits.

	QU_COMPILE_MAXLEVEL is the maximum number of nested blocks.

	QU_COMPILE_MAXDEPTH is the maximum number of nested expressions.

	QU_COMPILE_MAXARGS is the maximum number of arguments, items, etc.
	For one thing, it keeps a reasonable frame stack size.

	@warn
	QU_COMPILE_MAXLEVEL is tigthly related to ={Frame} objects. The bigger
	it is, the bigger the qu_frame object size is. It is generally a bad
	idea to change this setting.
*/
#define QU_COMPILE_MAXLEVEL 8
#define QU_COMPILE_MAXDEPTH 32
#define QU_COMPILE_MAXARGS  0xFFF


/** __QuCompileIsCompiling
	To make sure that we don't accidentally call script functions while
	compiling. If we do, then there is something wrong with our logic.
*/
extern int volatile __QuCompileIsCompiling;


/** qu_compile_main
	Compile the main program.

	Do not call this function directly.
	It is called by the main program.
*/
extern qu_module qu_compile_main (qu_string s, int ispath);


/** qu_compile_eval
	Compile an eval module.

	Do not call this function directly.
	It is designed for the interpreter.
*/
extern qu_module qu_compile_eval (qu_module m, int docstring);


/***/
/* called internally by the main program initialize the compiler */
extern void qu_compile__init ();

#endif /*_H_qu_compile_*/
