/* Proc.h - Copyright (c) Marc Krisnanto */

#ifndef _H_qu_proc_
#define _H_qu_proc_ 1


/** Proc
	The final Proc class.

	The Proc class allows foreign C functions to call Qu functions.

	@warn
	The Proc class needs GNU Lightning.
*/
extern qu_class QuProcClass;


/** qu_proc
	qu_proc represents an instance of the Proc class.
	It is a pointer to the instance struct qu_proc_s.
*/
struct qu_proc_s
{
	QU_OBJECT_HEAD;
	char   *code; /* (jit_insn *) the C code interface - qu_mem_alloc'ed */
	qu_sub  sub;  /* the Q qu_sub to call */
};


/** QU_PROC_FLAG
	Flags used by Proc objects.
*/
/* none but all reserved */


/** qu_proc_is
	Whether the object is a Proc.
*/
#define qu_proc_is(o) (qu_classof (o) == QuProcClass)


/** qu_proc_as_string
	Return a String representation.
*/
#define qu_proc_as_string(self) qu__proc__string (self)


/***/
/*--------------------------------------------------------------------------*/

/* called internally by Class to initialize this class */
extern void qu_proc__setup ();
extern void qu_proc__init  ();

/* for efficiency - may only be called from this file */
extern qu_string qu__proc__string (qu_proc self);

/* for Glib */
extern qu_proc qu_proc_glib_new (qu_any sub);

#endif /*_H_qu_proc_*/
