/* ascii.h - Copyright (c) Marc Krisnanto */

#ifndef _H_qu_ascii_
#define _H_qu_ascii_ 1

#include "base.h"


/** QU_ASCII
	Various ASCII character tables.
*/
extern unsigned char QU_ASCII_TOLOWER [256];
extern unsigned char QU_ASCII_TOUPPER [256];
extern unsigned char QU_ASCII_TOPRINT [256];
extern unsigned char QU_ASCII_TOTEXT  [256];
extern unsigned char QU_ASCII_TOTITLE [256];
extern unsigned char QU_ASCII_ISLOWER [256];
extern unsigned char QU_ASCII_ISUPPER [256];
extern unsigned char QU_ASCII_ISALPHA [256];
extern unsigned char QU_ASCII_ISDIGIT [256];
extern unsigned char QU_ASCII_ISALNUM [256];
extern unsigned char QU_ASCII_ISIDENT [256];
extern unsigned char QU_ASCII_ISIDNUM [256];
extern unsigned char QU_ASCII_ISXDIGIT[256];
extern unsigned char QU_ASCII_ISODIGIT[256];
extern unsigned char QU_ASCII_ISBDIGIT[256];
extern unsigned char QU_ASCII_ISSPACE [256];
extern unsigned char QU_ASCII_ISBLANK [256];
extern unsigned char QU_ASCII_ISWHITE [256];
extern unsigned char QU_ASCII_ISWORD  [256];
extern unsigned char QU_ASCII_ISPWD   [256];
extern unsigned char QU_ASCII_ISNAME  [256];
extern unsigned char QU_ASCII_ISCNTRL [256];
extern unsigned char QU_ASCII_ISPUNCT [256];
extern unsigned char QU_ASCII_ISGRAPH [256];
extern unsigned char QU_ASCII_ISPRINT [256];
extern unsigned char QU_ASCII_ISTEXT  [256];
extern unsigned char QU_ASCII_ISPATH  [256];
extern unsigned char QU_ASCII_HEXVAL  [256];
extern unsigned char QU_ASCII_TOIDENT [256];
extern unsigned char QU_ASCII_TOSWAP  [256];


/** QU_ASCII_DIGIT
	All digits.
*/
extern char QU_ASCII_DIGITL[36]; /* 0123456789abcdefghijklmnopqrstuvwxyz */
extern char QU_ASCII_DIGITU[36]; /* 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ */


/** qu_ascii_hexval
	Returns the hex value of a character, -1 if the character is not
	a valid hexadecimal character.
*/
#define qu_ascii_hexval(c)  (QU_ASCII_HEXVAL [255 & (c)])


/** qu_ascii_to
	Convert an ASCII character.

	All macros are designed with no side-effect.
*/
#define qu_ascii_tolower(c)  ((char) QU_ASCII_TOLOWER [255 & (c)])
#define qu_ascii_toupper(c)  ((char) QU_ASCII_TOUPPER [255 & (c)])
#define qu_ascii_totitle(c)  ((char) QU_ASCII_TOTITLE [255 & (c)])
#define qu_ascii_toprint(c)  ((char) QU_ASCII_TOPRINT [255 & (c)])
#define qu_ascii_totext(c)   ((char) QU_ASCII_TOTEXT  [255 & (c)])
#define qu_ascii_toident(c)  ((char) QU_ASCII_TOIDENT [255 & (c)])
#define qu_ascii_toswap(c)   ((char) QU_ASCII_TOSWAP  [255 & (c)])


/** qu_ascii_is
	Test an ASCII character.

	All macros are designed with no side-effect.
*/
#define qu_ascii_islower(c)  (QU_ASCII_ISLOWER [255 & (c)])
#define qu_ascii_isupper(c)  (QU_ASCII_ISUPPER [255 & (c)])
#define qu_ascii_isalpha(c)  (QU_ASCII_ISALPHA [255 & (c)])
#define qu_ascii_isdigit(c)  (QU_ASCII_ISDIGIT [255 & (c)])
#define qu_ascii_isalnum(c)  (QU_ASCII_ISALNUM [255 & (c)])
#define qu_ascii_isxdigit(c) (QU_ASCII_ISXDIGIT[255 & (c)])
#define qu_ascii_isspace(c)  (QU_ASCII_ISSPACE [255 & (c)])
#define qu_ascii_isblank(c)  (QU_ASCII_ISBLANK [255 & (c)])
#define qu_ascii_iscntrl(c)  (QU_ASCII_ISCNTRL [255 & (c)])
#define qu_ascii_ispunct(c)  (QU_ASCII_ISPUNCT [255 & (c)])
#define qu_ascii_isgraph(c)  (QU_ASCII_ISGRAPH [255 & (c)])
#define qu_ascii_isprint(c)  (QU_ASCII_ISPRINT [255 & (c)])
#define qu_ascii_istext(c)   (QU_ASCII_ISTEXT  [255 & (c)])
#define qu_ascii_isident(c)  (QU_ASCII_ISIDENT [255 & (c)])
#define qu_ascii_isidnum(c)  (QU_ASCII_ISIDNUM [255 & (c)])
#define qu_ascii_isodigit(c) (QU_ASCII_ISODIGIT[255 & (c)])
#define qu_ascii_iswhite(c)  (QU_ASCII_ISWHITE [255 & (c)])
#define qu_ascii_isword(c)   (QU_ASCII_ISWORD  [255 & (c)])
#define qu_ascii_ispwd(c)    (QU_ASCII_ISPWD   [255 & (c)])
#define qu_ascii_isname(c)   (QU_ASCII_ISNAME  [255 & (c)])
#define qu_ascii_ispath(c)   (QU_ASCII_ISPATH  [255 & (c)])

/***/
#endif /*_H_qu_ascii_*/
