/* attrs.h - Copyright (c) Marc Krisnanto */

#if defined(QU_ATTRS_IN_HEADER)

#	undef QU_ATTRS_IN_HEADER
#	ifdef QU_ATTRS_HEADER_USED
#		error *** invalid usage
#	else
#		define QU_ATTRS_HEADER_USED 1
#	endif
#	define a_(name) extern qu_string QU_NAME_##name
#	define u_(name) extern qu_string QU_NAME_##name

#elif defined(QU_ATTRS_IN_SOURCE_DECL)

#	undef QU_ATTRS_IN_SOURCE_DECL
#	ifdef QU_ATTRS_SOURCE_DECL_USED
#		error *** invalid usage
#	else
#		define QU_ATTRS_SOURCE_DECL_USED 1
#	endif
#	define a_(name) qu_string QU_NAME_##name
#	define u_(name) qu_string QU_NAME_##name

#elif defined(QU_ATTRS_IN_SOURCE_INIT)

#	undef QU_ATTRS_IN_SOURCE_INIT
#	ifdef QU_ATTRS_SOURCE_INIT_USED
#		error *** invalid usage
#	else
#		define QU_ATTRS_SOURCE_INIT_USED 1
#	endif
#	define a_(name) QU_NAME_##name = qu_string_new_staticz (#name)
#	define u_(name) QU_NAME_##name = qu_string_new_staticz ("_" #name)

#endif


/** QU_NAME_XXX
	List of standard attribute names. All are predefined static ={String} objects
	created by ={Class} at initialization time.

	To get the real symbol name, prepend C{QU_NAME_} to the v{a_} macros and
	C{QU_NAME__} to the v{u_} macros.

	@xmp
		QU_NAME_new   -> "new"
		QU_NAME__plus -> "__plus"
*/
a_(classof);
a_(flags);
a_(ident);
a_(name);
a_(new);

a_(clear);
a_(copy);
a_(delete);
a_(len);

u_(_attrs);
u_(_args);
u_(_block);
u_(_code);
u_(_decl);
u_(_defines);
u_(_doc);
u_(_flags);
u_(_ident);
u_(_isa);
u_(_isabstract);
u_(_isauto);
u_(_isextern);
u_(_isfinal);
u_(_ismixin);
u_(_isprivate);
u_(_issuper);
u_(_master);
u_(_mixes);
u_(_mixins);
u_(_module);
u_(_name);
u_(_rank);
u_(_root);
u_(_storable);
u_(_super);
u_(_tree);
u_(_where);

u_(_as);
u_(_call);
u_(_class);
u_(_clear);
u_(_cmp);
u_(_copy);
u_(_decr);
u_(_del);
u_(_destroy);
u_(_div);
u_(_each);
u_(_eq);
u_(_format);
u_(_get);
u_(_getitem);
u_(_getslice);
u_(_hash);
u_(_iand);
u_(_id);
u_(_idiv);
u_(_in);
u_(_incr);
u_(_init);
u_(_inot);
u_(_inst);
u_(_iterable);
u_(_ior);
u_(_ixor);
u_(_len);
u_(_like);
u_(_load);
u_(_lshift);
u_(_minus);
u_(_mul);
u_(_neg);
u_(_next);
u_(_not);
u_(_of);
u_(_plus);
u_(_pop);
u_(_pos);
u_(_pow);
u_(_print);
u_(_push);
u_(_rem);
u_(_set);
u_(_setitem);
u_(_setslice);
u_(_static);
u_(_stop);
u_(_store);
u_(_string);
u_(_rshift);
u_(_tag);
u_(_true);
u_(_typeof);
u_(_version);
u_(_weak);


/***/
#undef a_
#undef u_
