#ifndef _mysql_h
#define _mysql_h

typedef struct MYSQL MYSQL;
typedef struct MYSQL_RES MYSQL_RES;
typedef char **MYSQL_ROW;


typedef struct MYSQL_FIELD MYSQL_FIELD;
struct MYSQL_FIELD
{
	char         *name;       /* <- we need this */
	char         *table;
	char         *def;
	int           type;       /* <- and this */
	unsigned int  length;
	unsigned int  max_length;
	unsigned int  flags;
	unsigned int  decimals;
};

/* !!! Mysql changed the damn struct completely since perhaps ver.4 */
typedef struct MYSQL_FIELD_NEW MYSQL_FIELD_NEW;
struct MYSQL_FIELD_NEW
{
	char *name;                    /* <- we need this */
	char *org_name;
	char *table;
	char *org_table;
	char *db;
	char *catalog;
	char *def;
	unsigned long length;
	unsigned long max_length;
	unsigned int name_length;
	unsigned int org_name_length;
	unsigned int table_length;
	unsigned int org_table_length;
	unsigned int db_length;
	unsigned int catalog_length;
	unsigned int def_length;
	unsigned int flags;
	unsigned int decimals;
	unsigned int charsetnr;
	int type;                      /* <- and this */
};

#define MYSQL_FIELD_GET_NAME(f, i) f[i].name
#define MYSQL_FIELD_GET_TYPE(f, i) f[i].type

static void                (*mysql_close             ) (MYSQL *m);
static void                (*mysql_free_result       ) (MYSQL_RES *r);
static unsigned int        (*mysql_thread_safe       ) (void);
static MYSQL              *(*mysql_init              ) (MYSQL *m);
static MYSQL              *(*mysql_real_connect      ) (MYSQL *m, const char *host, const char *usr, const char *pwd, const char *db, unsigned int port, const char *usock, unsigned int flag);
static unsigned int        (*mysql_errno             ) (MYSQL *m);
static char               *(*mysql_error             ) (MYSQL *m);
static int                *(*mysql_query             ) (MYSQL *m, const char *q);
static unsigned long       (*mysql_affected_rows_l   ) (MYSQL *m);
static unsigned long       (*mysql_insert_id_l       ) (MYSQL *m);
static unsigned long long  (*mysql_affected_rows     ) (MYSQL *m);
static unsigned long long  (*mysql_insert_id         ) (MYSQL *m);
static MYSQL_RES          *(*mysql_use_result        ) (MYSQL *m);
static MYSQL_ROW           (*mysql_fetch_row         ) (MYSQL_RES *r);
static unsigned int        (*mysql_num_fields        ) (MYSQL_RES *r);
static MYSQL_FIELD        *(*mysql_fetch_fields      ) (MYSQL_RES *r);
static unsigned long       (*mysql_real_escape_string) (MYSQL *m, char *to, const char *from, unsigned long len);

#define MYSQL_TYPE_DECIMAL      0
#define MYSQL_TYPE_TINY         1
#define MYSQL_TYPE_SHORT        2
#define MYSQL_TYPE_LONG         3
#define MYSQL_TYPE_FLOAT        4
#define MYSQL_TYPE_DOUBLE       5
#define MYSQL_TYPE_NULL         6
#define MYSQL_TYPE_TIMESTAMP    7
#define MYSQL_TYPE_LONGLONG     8
#define MYSQL_TYPE_INT24        9
#define MYSQL_TYPE_DATE         10
#define MYSQL_TYPE_TIME         11
#define MYSQL_TYPE_DATETIME     12
#define MYSQL_TYPE_YEAR         13
#define MYSQL_TYPE_NEWDATE      14
#define MYSQL_TYPE_ENUM         247
#define MYSQL_TYPE_SET          248
#define MYSQL_TYPE_TINY_BLOB    249
#define MYSQL_TYPE_MEDIUM_BLOB  250
#define MYSQL_TYPE_LONG_BLOB    251
#define MYSQL_TYPE_BLOB         252
#define MYSQL_TYPE_VAR_STRING   253
#define MYSQL_TYPE_STRING       254
#define MYSQL_TYPE_GEOMETRY     255

#define CLIENT_FOUND_ROWS	2

#endif /*_mysql_h*/
