#ifndef _H_gd_
#define _H_gd_ 1

typedef struct gdImagePtr_s gdImagePtr_s;
struct gdImagePtr_s
{
	unsigned char **pixels;
	int sx;
	int sy;
	/* we don't care about the rest */
};
typedef struct gdImagePtr_s *gdImagePtr;
typedef void *gdFontPtr;


static void        (*gdImageDestroy          ) (gdImagePtr im);
static void        (*gdFree                  ) (void *data);
static gdImagePtr  (*gdImageCreate           ) (int w, int h);
static gdImagePtr  (*gdImageCreateTrueColor  ) (int w, int h);
static gdImagePtr  (*gdImageCreateFromJpeg   ) (FILE *f);
static gdImagePtr  (*gdImageCreateFromJPegPtr) (int size, void *data);
static gdImagePtr  (*gdImageCreateFromPng    ) (FILE *f);
static gdImagePtr  (*gdImageCreateFromPngPtr ) (int size, void *data);
static gdImagePtr  (*gdImageCreateFromGif    ) (FILE *f);
static gdImagePtr  (*gdImageCreateFromGifPtr ) (int size, void *data);
static gdImagePtr  (*gdImageCreateFromXpm    ) (FILE *f);
static gdImagePtr  (*gdImageCreateFromXpmPtr ) (int size, void *data);
static gdImagePtr  (*gdImageCreateFromXbm    ) (FILE *f);
static gdImagePtr  (*gdImageCreateFromXbmPtr ) (int size, void *data);
static gdImagePtr  (*gdImageCreateFromGd     ) (FILE *f);
static gdImagePtr  (*gdImageCreateFromGdPtr  ) (int size, void *data);
static gdImagePtr  (*gdImageCreateFromGd2    ) (FILE *f);
static gdImagePtr  (*gdImageCreateFromGd2Ptr ) (int size, void *data);
static void        (*gdImageJpeg             ) (gdImagePtr im, FILE *f, int quality);
static void       *(*gdImageJpegPtr          ) (gdImagePtr im, int *size, int quality);
static void        (*gdImagePng              ) (gdImagePtr im, FILE *f);
static void       *(*gdImagePngPtr           ) (gdImagePtr im, int *size);
static void        (*gdImageGif              ) (gdImagePtr im, FILE *f);
static void       *(*gdImageGifPtr           ) (gdImagePtr im, int *size);
static void        (*gdImageXpm              ) (gdImagePtr im, FILE *f);
static void       *(*gdImageXpmPtr           ) (gdImagePtr im, int *size);
static void        (*gdImageXbm              ) (gdImagePtr im, FILE *f);
static void       *(*gdImageXbmPtr           ) (gdImagePtr im, int *size);
static void        (*gdImageGd               ) (gdImagePtr im, FILE *f);
static void       *(*gdImageGdPtr            ) (gdImagePtr im, int *size);
static void        (*gdImageGd2              ) (gdImagePtr im, FILE *f);
static void       *(*gdImageGd2Ptr           ) (gdImagePtr im, int *size);
static void        (*gdImageSetClip          ) (gdImagePtr im, int x1, int y1, int x2, int y2);
static int         (*gdImageColorAllocate    ) (gdImagePtr im, int r, int g, int b);
static void        (*gdImageSetPixel         ) (gdImagePtr im, int x, int y, int color);
static int         (*gdImageGetPixel         ) (gdImagePtr im, int x, int y);
static void        (*gdImageLine             ) (gdImagePtr im, int x1, int y1, int x2, int y2, int color);
static void        (*gdImageArc              ) (gdImagePtr im, int cx, int cy, int w, int h, int s, int e, int color);
static void        (*gdImageFill             ) (gdImagePtr im, int x, int y, int color);
static void        (*gdImageFillToBorder     ) (gdImagePtr im, int x, int y, int border, int color);
static void        (*gdImageChar             ) (gdImagePtr im, gdFontPtr f, int x, int y, int c, int color);
static void        (*gdImageString           ) (gdImagePtr im, gdFontPtr f, int x, int y, unsigned char *s, int color);

static gdFontPtr     gdFontTiny;
static gdFontPtr     gdFontSmall;
static gdFontPtr     gdFontMediumBold;
static gdFontPtr     gdFontLarge;
static gdFontPtr     gdFontGiant;

#endif /*_H_gd_*/
