/* GtkAction.c - Copyright (c) Marc Krisnanto */
/*
	Callbacks which first argument is a GObject representing self.
*/


static void qu_gtk_action_void (GObject *g, void *a1, int argc)
{
	qu_gobject self = qu_gtk_from_gobject (g);
	if (self && self->action)
	{
		qu_any argv [MAXARGS];
		qu_callback x = self->action;

		ENTER;
		if (argc)
			qu_gtk_callback_setarg (x->sub, a1, argc, argv);
		if (qu_sub_calln (x->sub, self, argc, argv) == 0)
			QU_SYS_WARN ("%s threw an exception", x->sub->name->str);
		LEAVE;
	}
}


static void qu_gtk_action_void_0 (GObject *g)
{
	qu_gtk_action_void (g, NULL, 0);
}


static void qu_gtk_action_void_1 (GObject *g, long a1)
{
	qu_gtk_action_void (g, &a1, 1);
}


static void qu_gtk_action_void_2 (GObject *g, long a1, long a2)
{
	qu_gtk_action_void (g, &a1, 2);
}


static void qu_gtk_action_void_3 (GObject *g, long a1, long a2, long a3)
{
	qu_gtk_action_void (g, &a1, 3);
}


static void qu_gtk_action_void_4 (GObject *g, long a1, long a2, long a3, long a4)
{
	qu_gtk_action_void (g, &a1, 4);
}


static void qu_gtk_action_void_5 (GObject *g, long a1, long a2, long a3, long a4, long a5)
{
	qu_gtk_action_void (g, &a1, 5);
}


static void qu_gtk_action_void_6 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6)
{
	qu_gtk_action_void (g, &a1, 6);
}


static void qu_gtk_action_void_7 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6, long a7)
{
	qu_gtk_action_void (g, &a1, 7);
}


static void qu_gtk_action_void_8 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8)
{
	qu_gtk_action_void (g, &a1, 8);
}



/*--------------------------------------------------------------------------*/
static int qu_gtk_action_boolean (GObject *g, void *a1, int argc)
{
	qu_gobject self = qu_gtk_from_gobject (g);
	int r = 0;
	if (self && self->action)
	{
		qu_any argv [MAXARGS], o;
		qu_callback x = self->action;

		ENTER;
		if (argc)
			qu_gtk_callback_setarg (x->sub, a1, argc, argv);
		o = qu_sub_calln (x->sub, x->self, argc, argv);
		if (o == 0)
		{
			QU_SYS_WARN ("%s threw an exception", x->sub->name->str);
		}
		else if (!qu_boolean_is (o))
		{
			QU_SYS_WARN ("%s did not return a boolean", x->sub->name->str);
		}
		r = (o == (qu_any) QuTrue);
		LEAVE;
	}
	return r;
}


static int qu_gtk_action_boolean_0 (GObject *g)
{
	return qu_gtk_action_boolean (g, NULL, 0);
}


static int qu_gtk_action_boolean_1 (GObject *g, long a1)
{
	return qu_gtk_action_boolean (g, &a1, 1);
}


static int qu_gtk_action_boolean_2 (GObject *g, long a1, long a2)
{
	return qu_gtk_action_boolean (g, &a1, 2);
}


static int qu_gtk_action_boolean_3 (GObject *g, long a1, long a2, long a3)
{
	return qu_gtk_action_boolean (g, &a1, 3);
}


static int qu_gtk_action_boolean_4 (GObject *g, long a1, long a2, long a3, long a4)
{
	return qu_gtk_action_boolean (g, &a1, 4);
}


static int qu_gtk_action_boolean_5 (GObject *g, long a1, long a2, long a3, long a4, long a5)
{
	return qu_gtk_action_boolean (g, &a1, 5);
}


static int qu_gtk_action_boolean_6 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6)
{
	return qu_gtk_action_boolean (g, &a1, 6);
}


static int qu_gtk_action_boolean_7 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6, long a7)
{
	return qu_gtk_action_boolean (g, &a1, 7);
}


static int qu_gtk_action_boolean_8 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8)
{
	return qu_gtk_action_boolean (g, &a1, 8);
}



/*--------------------------------------------------------------------------*/
static int qu_gtk_action_int (GObject *g, void *a1, int argc)
{
	qu_gobject self = qu_gtk_from_gobject (g);
	int r = 0;
	if (self && self->action)
	{
		qu_any argv [MAXARGS], o;
		qu_callback x = self->action;

		ENTER;
		if (argc)
			qu_gtk_callback_setarg (x->sub, a1, argc, argv);
		o = qu_sub_calln (x->sub, x->self, argc, argv);
		if (o == 0)
		{
			QU_SYS_WARN ("%s threw an exception", x->sub->name->str);
		}
		else
		{
			r = qu_integer_toi (o);
			if (errno)
			{
				QU_SYS_WARN ("%s did not return a boolean", x->sub->name->str);
				r = 0;
			}
		}
		LEAVE;
	}
	return r;
}


static int qu_gtk_action_int_0 (GObject *g)
{
	return qu_gtk_action_int (g, NULL, 0);
}


static int qu_gtk_action_int_1 (GObject *g, long a1)
{
	return qu_gtk_action_int (g, &a1, 1);
}


static int qu_gtk_action_int_2 (GObject *g, long a1, long a2)
{
	return qu_gtk_action_int (g, &a1, 2);
}


static int qu_gtk_action_int_3 (GObject *g, long a1, long a2, long a3)
{
	return qu_gtk_action_int (g, &a1, 3);
}


static int qu_gtk_action_int_4 (GObject *g, long a1, long a2, long a3, long a4)
{
	return qu_gtk_action_int (g, &a1, 4);
}


static int qu_gtk_action_int_5 (GObject *g, long a1, long a2, long a3, long a4, long a5)
{
	return qu_gtk_action_int (g, &a1, 5);
}


static int qu_gtk_action_int_6 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6)
{
	return qu_gtk_action_int (g, &a1, 6);
}


static int qu_gtk_action_int_7 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6, long a7)
{
	return qu_gtk_action_int (g, &a1, 7);
}


static int qu_gtk_action_int_8 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8)
{
	return qu_gtk_action_int (g, &a1, 8);
}



/*--------------------------------------------------------------------------*/
static float qu_gtk_action_float (GObject *g, void *a1, int argc)
{
	qu_gobject self = qu_gtk_from_gobject (g);
	float r = 0;
	if (self && self->action)
	{
		qu_any argv [MAXARGS], o;
		qu_callback x = self->action;

		ENTER;
		if (argc)
			qu_gtk_callback_setarg (x->sub, a1, argc, argv);
		o = qu_sub_calln (x->sub, x->self, argc, argv);
		if (o == 0)
		{
			QU_SYS_WARN ("%s threw an exception", x->sub->name->str);
		}
		else
		{
			r = qu_decimal_tof (o);
			if (errno)
			{
				QU_SYS_WARN ("%s did not return a float", x->sub->name->str);
				r = 0;
			}
		}
		LEAVE;
	}
	return r;
}


static float qu_gtk_action_float_0 (GObject *g)
{
	return qu_gtk_action_float (g, NULL, 0);
}


static float qu_gtk_action_float_1 (GObject *g, long a1)
{
	return qu_gtk_action_float (g, &a1, 1);
}


static float qu_gtk_action_float_2 (GObject *g, long a1, long a2)
{
	return qu_gtk_action_float (g, &a1, 2);
}


static float qu_gtk_action_float_3 (GObject *g, long a1, long a2, long a3)
{
	return qu_gtk_action_float (g, &a1, 3);
}


static float qu_gtk_action_float_4 (GObject *g, long a1, long a2, long a3, long a4)
{
	return qu_gtk_action_float (g, &a1, 4);
}


static float qu_gtk_action_float_5 (GObject *g, long a1, long a2, long a3, long a4, long a5)
{
	return qu_gtk_action_float (g, &a1, 5);
}


static float qu_gtk_action_float_6 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6)
{
	return qu_gtk_action_float (g, &a1, 6);
}


static float qu_gtk_action_float_7 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6, long a7)
{
	return qu_gtk_action_float (g, &a1, 7);
}


static float qu_gtk_action_float_8 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8)
{
	return qu_gtk_action_float (g, &a1, 8);
}



/*--------------------------------------------------------------------------*/
static double qu_gtk_action_double (GObject *g, void *a1, int argc)
{
	qu_gobject self = qu_gtk_from_gobject (g);
	double r = 0;
	if (self && self->action)
	{
		qu_any argv [MAXARGS], o;
		qu_callback x = self->action;

		ENTER;
		if (argc)
			qu_gtk_callback_setarg (x->sub, a1, argc, argv);
		o = qu_sub_calln (x->sub, x->self, argc, argv);
		if (o == 0)
		{
			QU_SYS_WARN ("%s threw an exception", x->sub->name->str);
		}
		else
		{
			r = qu_decimal_tod (o);
			if (errno)
			{
				QU_SYS_WARN ("%s did not return a double", x->sub->name->str);
				r = 0;
			}
		}
		LEAVE;
	}
	return r;
}


static double qu_gtk_action_double_0 (GObject *g)
{
	return qu_gtk_action_double (g, NULL, 0);
}


static double qu_gtk_action_double_1 (GObject *g, long a1)
{
	return qu_gtk_action_double (g, &a1, 1);
}


static double qu_gtk_action_double_2 (GObject *g, long a1, long a2)
{
	return qu_gtk_action_double (g, &a1, 2);
}


static double qu_gtk_action_double_3 (GObject *g, long a1, long a2, long a3)
{
	return qu_gtk_action_double (g, &a1, 3);
}


static double qu_gtk_action_double_4 (GObject *g, long a1, long a2, long a3, long a4)
{
	return qu_gtk_action_double (g, &a1, 4);
}


static double qu_gtk_action_double_5 (GObject *g, long a1, long a2, long a3, long a4, long a5)
{
	return qu_gtk_action_double (g, &a1, 5);
}


static double qu_gtk_action_double_6 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6)
{
	return qu_gtk_action_double (g, &a1, 6);
}


static double qu_gtk_action_double_7 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6, long a7)
{
	return qu_gtk_action_double (g, &a1, 7);
}


static double qu_gtk_action_double_8 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8)
{
	return qu_gtk_action_double (g, &a1, 8);
}



/*--------------------------------------------------------------------------*/
/*
	!!! I am assuming that all char * returned value must be Glib allocated

	If this is not the case then we will have to rely on the programmers
	to call g_strdup (or whatever) from Qu.
*/
static char *qu_gtk_action_string (GObject *g, void *a1, int argc)
{
	qu_gobject self = qu_gtk_from_gobject (g);
	char *r = NULL;
	if (self && self->action)
	{
		qu_any argv [MAXARGS], o;
		qu_callback x = self->action;

		ENTER;
		if (argc)
			qu_gtk_callback_setarg (x->sub, a1, argc, argv);
		o = qu_sub_calln (x->sub, x->self, argc, argv);
		if (o == 0)
		{
			QU_SYS_WARN ("%s threw an exception", x->sub->name->str);
		}
		else if (!qu_stringy_is (o))
		{
			QU_SYS_WARN ("%s did not return a string", x->sub->name->str);
		}
		else
		{
			r = g_strdup (((qu_string) o)->str);
		}
		LEAVE;
	}
	return r;
}


static char *qu_gtk_action_string_0 (GObject *g)
{
	return qu_gtk_action_string (g, NULL, 0);
}


static char *qu_gtk_action_string_1 (GObject *g, long a1)
{
	return qu_gtk_action_string (g, &a1, 1);
}


static char *qu_gtk_action_string_2 (GObject *g, long a1, long a2)
{
	return qu_gtk_action_string (g, &a1, 2);
}


static char *qu_gtk_action_string_3 (GObject *g, long a1, long a2, long a3)
{
	return qu_gtk_action_string (g, &a1, 3);
}


static char *qu_gtk_action_string_4 (GObject *g, long a1, long a2, long a3, long a4)
{
	return qu_gtk_action_string (g, &a1, 4);
}


static char *qu_gtk_action_string_5 (GObject *g, long a1, long a2, long a3, long a4, long a5)
{
	return qu_gtk_action_string (g, &a1, 5);
}


static char *qu_gtk_action_string_6 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6)
{
	return qu_gtk_action_string (g, &a1, 6);
}


static char *qu_gtk_action_string_7 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6, long a7)
{
	return qu_gtk_action_string (g, &a1, 7);
}


static char *qu_gtk_action_string_8 (GObject *g, long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8)
{
	return qu_gtk_action_string (g, &a1, 8);
}


/*--------------------------------------------------------------------------*/

static void *qu_gtk_action_getfunc (qu_sub u)
{
	if (u->type == 0)
	{
		switch (u->argc)
		{
			case 0: return qu_gtk_action_void_0;
			case 1: return qu_gtk_action_void_1;
			case 2: return qu_gtk_action_void_2;
			case 3: return qu_gtk_action_void_3;
			case 4: return qu_gtk_action_void_4;
			case 5: return qu_gtk_action_void_5;
			case 6: return qu_gtk_action_void_6;
			case 7: return qu_gtk_action_void_7;
			case 8: return qu_gtk_action_void_8;
			default: QU_FATAL ("never");
		}
	}
	else
	{
		switch (qu_struct_type_to_char (u->type))
		{
			case QU_STRUCT_ID_Boolean:
				switch (u->argc)
				{
					case 0: return qu_gtk_action_boolean_0;
					case 1: return qu_gtk_action_boolean_1;
					case 2: return qu_gtk_action_boolean_2;
					case 3: return qu_gtk_action_boolean_3;
					case 4: return qu_gtk_action_boolean_4;
					case 5: return qu_gtk_action_boolean_5;
					case 6: return qu_gtk_action_boolean_6;
					case 7: return qu_gtk_action_boolean_7;
					case 8: return qu_gtk_action_boolean_8;
					default: QU_FATAL ("never");
				}
				break;

			case QU_STRUCT_ID_int:
				switch (u->argc)
				{
					case 0: return qu_gtk_action_int_0;
					case 1: return qu_gtk_action_int_1;
					case 2: return qu_gtk_action_int_2;
					case 3: return qu_gtk_action_int_3;
					case 4: return qu_gtk_action_int_4;
					case 5: return qu_gtk_action_int_5;
					case 6: return qu_gtk_action_int_6;
					case 7: return qu_gtk_action_int_7;
					case 8: return qu_gtk_action_int_8;
					default: QU_FATAL ("never");
				}
				break;

			case QU_STRUCT_ID_float:
				switch (u->argc)
				{
					case 0: return qu_gtk_action_float_0;
					case 1: return qu_gtk_action_float_1;
					case 2: return qu_gtk_action_float_2;
					case 3: return qu_gtk_action_float_3;
					case 4: return qu_gtk_action_float_4;
					case 5: return qu_gtk_action_float_5;
					case 6: return qu_gtk_action_float_6;
					case 7: return qu_gtk_action_float_7;
					case 8: return qu_gtk_action_float_8;
					default: QU_FATAL ("never");
				}
				break;

			case QU_STRUCT_ID_double:
				switch (u->argc)
				{
					case 0: return qu_gtk_action_double_0;
					case 1: return qu_gtk_action_double_1;
					case 2: return qu_gtk_action_double_2;
					case 3: return qu_gtk_action_double_3;
					case 4: return qu_gtk_action_double_4;
					case 5: return qu_gtk_action_double_5;
					case 6: return qu_gtk_action_double_6;
					case 7: return qu_gtk_action_double_7;
					case 8: return qu_gtk_action_double_8;
					default: QU_FATAL ("never");
				}
				break;

			case QU_STRUCT_ID_String:
				switch (u->argc)
				{
					case 0: return qu_gtk_action_string_0;
					case 1: return qu_gtk_action_string_1;
					case 2: return qu_gtk_action_string_2;
					case 3: return qu_gtk_action_string_3;
					case 4: return qu_gtk_action_string_4;
					case 5: return qu_gtk_action_string_5;
					case 6: return qu_gtk_action_string_6;
					case 7: return qu_gtk_action_string_7;
					case 8: return qu_gtk_action_string_8;
					default: QU_FATAL ("never");
				}
				break;
		}
	}
	QU_FATAL ("never");
	return 0;
}
