/* GtkHook.c - Copyright (c) Marc Krisnanto */
/*
	Callbacks which last argument is user_data.
	We use that argument to store our callback information.
*/


static void qu_gtk_hook_void (qu_callback x, void *a1, int argc)
{
	qu_any argv [MAXARGS];
	ENTER;
	if (argc)
		qu_gtk_callback_setarg (x->sub, a1, argc, argv);
	if (qu_sub_calln (x->sub, x->self, argc, argv) == 0)
		QU_SYS_WARN ("%s threw an exception", x->sub->name->str);
	LEAVE;
}


static void qu_gtk_hook_void_0 (qu_callback x)
{
	qu_gtk_hook_void (x, NULL, 0);
}


static void qu_gtk_hook_void_1 (long a1, qu_callback x)
{
	qu_gtk_hook_void (x, &a1, 1);
}


static void qu_gtk_hook_void_2 (long a1, long a2, qu_callback x)
{
	qu_gtk_hook_void (x, &a1, 2);
}


static void qu_gtk_hook_void_3 (long a1, long a2, long a3, qu_callback x)
{
	qu_gtk_hook_void (x, &a1, 3);
}


static void qu_gtk_hook_void_4 (long a1, long a2, long a3, long a4, qu_callback x)
{
	qu_gtk_hook_void (x, &a1, 4);
}


static void qu_gtk_hook_void_5 (long a1, long a2, long a3, long a4, long a5, qu_callback x)
{
	qu_gtk_hook_void (x, &a1, 5);
}


static void qu_gtk_hook_void_6 (long a1, long a2, long a3, long a4, long a5, long a6, qu_callback x)
{
	qu_gtk_hook_void (x, &a1, 6);
}


static void qu_gtk_hook_void_7 (long a1, long a2, long a3, long a4, long a5, long a6, long a7, qu_callback x)
{
	qu_gtk_hook_void (x, &a1, 7);
}


static void qu_gtk_hook_void_8 (long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8, qu_callback x)
{
	qu_gtk_hook_void (x, &a1, 8);
}



/*--------------------------------------------------------------------------*/
static int qu_gtk_hook_boolean (qu_callback x, void *a1, int argc)
{
	qu_any argv [MAXARGS], o;
	int r;

	ENTER;
	if (argc)
		qu_gtk_callback_setarg (x->sub, a1, argc, argv);
	o = qu_sub_calln (x->sub, x->self, argc, argv);
	if (o == 0)
	{
		QU_SYS_WARN ("%s threw an exception", x->sub->name->str);
	}
	else if (!qu_boolean_is (o))
	{
		QU_SYS_WARN ("%s did not return a boolean", x->sub->name->str);
	}
	r = (o == (qu_any) QuTrue);
	LEAVE;
	return r;
}


static int qu_gtk_hook_boolean_0 (qu_callback x)
{
	return qu_gtk_hook_boolean (x, NULL, 0);
}


static int qu_gtk_hook_boolean_1 (long a1, qu_callback x)
{
	return qu_gtk_hook_boolean (x, &a1, 1);
}


static int qu_gtk_hook_boolean_2 (long a1, long a2, qu_callback x)
{
	return qu_gtk_hook_boolean (x, &a1, 2);
}


static int qu_gtk_hook_boolean_3 (long a1, long a2, long a3, qu_callback x)
{
	return qu_gtk_hook_boolean (x, &a1, 3);
}


static int qu_gtk_hook_boolean_4 (long a1, long a2, long a3, long a4, qu_callback x)
{
	return qu_gtk_hook_boolean (x, &a1, 4);
}


static int qu_gtk_hook_boolean_5 (long a1, long a2, long a3, long a4, long a5, qu_callback x)
{
	return qu_gtk_hook_boolean (x, &a1, 5);
}


static int qu_gtk_hook_boolean_6 (long a1, long a2, long a3, long a4, long a5, long a6, qu_callback x)
{
	return qu_gtk_hook_boolean (x, &a1, 6);
}


static int qu_gtk_hook_boolean_7 (long a1, long a2, long a3, long a4, long a5, long a6, long a7, qu_callback x)
{
	return qu_gtk_hook_boolean (x, &a1, 7);
}


static int qu_gtk_hook_boolean_8 (long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8, qu_callback x)
{
	return qu_gtk_hook_boolean (x, &a1, 8);
}



/*--------------------------------------------------------------------------*/
static int qu_gtk_hook_int (qu_callback x, void *a1, int argc)
{
	qu_any argv [MAXARGS], o;
	int r = 0;

	ENTER;
	if (argc)
		qu_gtk_callback_setarg (x->sub, a1, argc, argv);
	o = qu_sub_calln (x->sub, x->self, argc, argv);
	if (o == 0)
	{
		QU_SYS_WARN ("%s threw an exception", x->sub->name->str);
	}
	else
	{
		r = qu_integer_toi (o);
		if (errno)
		{
			QU_SYS_WARN ("%s did not return a boolean", x->sub->name->str);
			r = 0;
		}
	}
	LEAVE;
	return r;
}


static int qu_gtk_hook_int_0 (qu_callback x)
{
	return qu_gtk_hook_int (x, NULL, 0);
}


static int qu_gtk_hook_int_1 (long a1, qu_callback x)
{
	return qu_gtk_hook_int (x, &a1, 1);
}


static int qu_gtk_hook_int_2 (long a1, long a2, qu_callback x)
{
	return qu_gtk_hook_int (x, &a1, 2);
}


static int qu_gtk_hook_int_3 (long a1, long a2, long a3, qu_callback x)
{
	return qu_gtk_hook_int (x, &a1, 3);
}


static int qu_gtk_hook_int_4 (long a1, long a2, long a3, long a4, qu_callback x)
{
	return qu_gtk_hook_int (x, &a1, 4);
}


static int qu_gtk_hook_int_5 (long a1, long a2, long a3, long a4, long a5, qu_callback x)
{
	return qu_gtk_hook_int (x, &a1, 5);
}


static int qu_gtk_hook_int_6 (long a1, long a2, long a3, long a4, long a5, long a6, qu_callback x)
{
	return qu_gtk_hook_int (x, &a1, 6);
}


static int qu_gtk_hook_int_7 (long a1, long a2, long a3, long a4, long a5, long a6, long a7, qu_callback x)
{
	return qu_gtk_hook_int (x, &a1, 7);
}


static int qu_gtk_hook_int_8 (long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8, qu_callback x)
{
	return qu_gtk_hook_int (x, &a1, 8);
}



/*--------------------------------------------------------------------------*/
static float qu_gtk_hook_float (qu_callback x, void *a1, int argc)
{
	qu_any argv [MAXARGS], o;
	float r = 0;

	ENTER;
	if (argc)
		qu_gtk_callback_setarg (x->sub, a1, argc, argv);
	o = qu_sub_calln (x->sub, x->self, argc, argv);
	if (o == 0)
	{
		QU_SYS_WARN ("%s threw an exception", x->sub->name->str);
	}
	else
	{
		r = qu_decimal_tof (o);
		if (errno)
		{
			QU_SYS_WARN ("%s did not return a float", x->sub->name->str);
			r = 0;
		}
	}
	LEAVE;
	return r;
}


static float qu_gtk_hook_float_0 (qu_callback x)
{
	return qu_gtk_hook_float (x, NULL, 0);
}


static float qu_gtk_hook_float_1 (long a1, qu_callback x)
{
	return qu_gtk_hook_float (x, &a1, 1);
}


static float qu_gtk_hook_float_2 (long a1, long a2, qu_callback x)
{
	return qu_gtk_hook_float (x, &a1, 2);
}


static float qu_gtk_hook_float_3 (long a1, long a2, long a3, qu_callback x)
{
	return qu_gtk_hook_float (x, &a1, 3);
}


static float qu_gtk_hook_float_4 (long a1, long a2, long a3, long a4, qu_callback x)
{
	return qu_gtk_hook_float (x, &a1, 4);
}


static float qu_gtk_hook_float_5 (long a1, long a2, long a3, long a4, long a5, qu_callback x)
{
	return qu_gtk_hook_float (x, &a1, 5);
}


static float qu_gtk_hook_float_6 (long a1, long a2, long a3, long a4, long a5, long a6, qu_callback x)
{
	return qu_gtk_hook_float (x, &a1, 6);
}


static float qu_gtk_hook_float_7 (long a1, long a2, long a3, long a4, long a5, long a6, long a7, qu_callback x)
{
	return qu_gtk_hook_float (x, &a1, 7);
}


static float qu_gtk_hook_float_8 (long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8, qu_callback x)
{
	return qu_gtk_hook_float (x, &a1, 8);
}



/*--------------------------------------------------------------------------*/
static double qu_gtk_hook_double (qu_callback x, void *a1, int argc)
{
	qu_any argv [MAXARGS], o;
	double r = 0;

	ENTER;
	if (argc)
		qu_gtk_callback_setarg (x->sub, a1, argc, argv);
	o = qu_sub_calln (x->sub, x->self, argc, argv);
	if (o == 0)
	{
		QU_SYS_WARN ("%s threw an exception", x->sub->name->str);
	}
	else
	{
		r = qu_decimal_tod (o);
		if (errno)
		{
			QU_SYS_WARN ("%s did not return a double", x->sub->name->str);
			r = 0;
		}
	}
	LEAVE;
	return r;
}


static double qu_gtk_hook_double_0 (qu_callback x)
{
	return qu_gtk_hook_double (x, NULL, 0);
}


static double qu_gtk_hook_double_1 (long a1, qu_callback x)
{
	return qu_gtk_hook_double (x, &a1, 1);
}


static double qu_gtk_hook_double_2 (long a1, long a2, qu_callback x)
{
	return qu_gtk_hook_double (x, &a1, 2);
}


static double qu_gtk_hook_double_3 (long a1, long a2, long a3, qu_callback x)
{
	return qu_gtk_hook_double (x, &a1, 3);
}


static double qu_gtk_hook_double_4 (long a1, long a2, long a3, long a4, qu_callback x)
{
	return qu_gtk_hook_double (x, &a1, 4);
}


static double qu_gtk_hook_double_5 (long a1, long a2, long a3, long a4, long a5, qu_callback x)
{
	return qu_gtk_hook_double (x, &a1, 5);
}


static double qu_gtk_hook_double_6 (long a1, long a2, long a3, long a4, long a5, long a6, qu_callback x)
{
	return qu_gtk_hook_double (x, &a1, 6);
}


static double qu_gtk_hook_double_7 (long a1, long a2, long a3, long a4, long a5, long a6, long a7, qu_callback x)
{
	return qu_gtk_hook_double (x, &a1, 7);
}


static double qu_gtk_hook_double_8 (long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8, qu_callback x)
{
	return qu_gtk_hook_double (x, &a1, 8);
}



/*--------------------------------------------------------------------------*/
/*
	!!! I am assuming that all char * returned value must be Glib allocated

	If this is not the case then we will have to rely on the programmers
	to call g_strdup (or whatever) from Qu.
*/
static char *qu_gtk_hook_string (qu_callback x, void *a1, int argc)
{
	qu_any argv [MAXARGS], o;
	char *r = NULL;

	ENTER;
	if (argc)
		qu_gtk_callback_setarg (x->sub, a1, argc, argv);
	o = qu_sub_calln (x->sub, x->self, argc, argv);
	if (o == 0)
	{
		QU_SYS_WARN ("%s threw an exception", x->sub->name->str);
	}
	else if (!qu_stringy_is (o))
	{
		QU_SYS_WARN ("%s did not return a string", x->sub->name->str);
	}
	else
	{
		r = g_strdup (((qu_string) o)->str);
	}
	LEAVE;
	return r;
}


static char *qu_gtk_hook_string_0 (qu_callback x)
{
	return qu_gtk_hook_string (x, NULL, 0);
}


static char *qu_gtk_hook_string_1 (long a1, qu_callback x)
{
	return qu_gtk_hook_string (x, &a1, 1);
}


static char *qu_gtk_hook_string_2 (long a1, long a2, qu_callback x)
{
	return qu_gtk_hook_string (x, &a1, 2);
}


static char *qu_gtk_hook_string_3 (long a1, long a2, long a3, qu_callback x)
{
	return qu_gtk_hook_string (x, &a1, 3);
}


static char *qu_gtk_hook_string_4 (long a1, long a2, long a3, long a4, qu_callback x)
{
	return qu_gtk_hook_string (x, &a1, 4);
}


static char *qu_gtk_hook_string_5 (long a1, long a2, long a3, long a4, long a5, qu_callback x)
{
	return qu_gtk_hook_string (x, &a1, 5);
}


static char *qu_gtk_hook_string_6 (long a1, long a2, long a3, long a4, long a5, long a6, qu_callback x)
{
	return qu_gtk_hook_string (x, &a1, 6);
}


static char *qu_gtk_hook_string_7 (long a1, long a2, long a3, long a4, long a5, long a6, long a7, qu_callback x)
{
	return qu_gtk_hook_string (x, &a1, 7);
}


static char *qu_gtk_hook_string_8 (long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8, qu_callback x)
{
	return qu_gtk_hook_string (x, &a1, 8);
}


/*--------------------------------------------------------------------------*/

static void *qu_gtk_hook_getfunc (qu_sub u)
{
	if (u->type == 0)
	{
		switch (u->argc)
		{
			case 0: return qu_gtk_hook_void_0;
			case 1: return qu_gtk_hook_void_1;
			case 2: return qu_gtk_hook_void_2;
			case 3: return qu_gtk_hook_void_3;
			case 4: return qu_gtk_hook_void_4;
			case 5: return qu_gtk_hook_void_5;
			case 6: return qu_gtk_hook_void_6;
			case 7: return qu_gtk_hook_void_7;
			case 8: return qu_gtk_hook_void_8;
			default: QU_FATAL ("never");
		}
	}
	else
	{
		switch (qu_struct_type_to_char (u->type))
		{
			case QU_STRUCT_ID_Boolean:
				switch (u->argc)
				{
					case 0: return qu_gtk_hook_boolean_0;
					case 1: return qu_gtk_hook_boolean_1;
					case 2: return qu_gtk_hook_boolean_2;
					case 3: return qu_gtk_hook_boolean_3;
					case 4: return qu_gtk_hook_boolean_4;
					case 5: return qu_gtk_hook_boolean_5;
					case 6: return qu_gtk_hook_boolean_6;
					case 7: return qu_gtk_hook_boolean_7;
					case 8: return qu_gtk_hook_boolean_8;
					default: QU_FATAL ("never");
				}
				break;

			case QU_STRUCT_ID_int:
				switch (u->argc)
				{
					case 0: return qu_gtk_hook_int_0;
					case 1: return qu_gtk_hook_int_1;
					case 2: return qu_gtk_hook_int_2;
					case 3: return qu_gtk_hook_int_3;
					case 4: return qu_gtk_hook_int_4;
					case 5: return qu_gtk_hook_int_5;
					case 6: return qu_gtk_hook_int_6;
					case 7: return qu_gtk_hook_int_7;
					case 8: return qu_gtk_hook_int_8;
					default: QU_FATAL ("never");
				}
				break;

			case QU_STRUCT_ID_float:
				switch (u->argc)
				{
					case 0: return qu_gtk_hook_float_0;
					case 1: return qu_gtk_hook_float_1;
					case 2: return qu_gtk_hook_float_2;
					case 3: return qu_gtk_hook_float_3;
					case 4: return qu_gtk_hook_float_4;
					case 5: return qu_gtk_hook_float_5;
					case 6: return qu_gtk_hook_float_6;
					case 7: return qu_gtk_hook_float_7;
					case 8: return qu_gtk_hook_float_8;
					default: QU_FATAL ("never");
				}
				break;

			case QU_STRUCT_ID_double:
				switch (u->argc)
				{
					case 0: return qu_gtk_hook_double_0;
					case 1: return qu_gtk_hook_double_1;
					case 2: return qu_gtk_hook_double_2;
					case 3: return qu_gtk_hook_double_3;
					case 4: return qu_gtk_hook_double_4;
					case 5: return qu_gtk_hook_double_5;
					case 6: return qu_gtk_hook_double_6;
					case 7: return qu_gtk_hook_double_7;
					case 8: return qu_gtk_hook_double_8;
					default: QU_FATAL ("never");
				}
				break;

			case QU_STRUCT_ID_String:
				switch (u->argc)
				{
					case 0: return qu_gtk_hook_string_0;
					case 1: return qu_gtk_hook_string_1;
					case 2: return qu_gtk_hook_string_2;
					case 3: return qu_gtk_hook_string_3;
					case 4: return qu_gtk_hook_string_4;
					case 5: return qu_gtk_hook_string_5;
					case 6: return qu_gtk_hook_string_6;
					case 7: return qu_gtk_hook_string_7;
					case 8: return qu_gtk_hook_string_8;
					default: QU_FATAL ("never");
				}
				break;
		}
	}
	QU_FATAL ("never");
	return 0;
}
