/*--------------------------------------------------------------------------*/
static void qu_gtk_signal_void (qu_callback x, long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8)
{
	qu_sub u    = x->sub;
	int    argc = u->argc;
	qu_any argv [MAXARGS];

	ENTER;
	if (argc)
		qu_gtk_callback_setarg (u, &a1, argc, argv);
	if (qu_sub_calln (u, x->self, argc, argv) == 0)
		QU_SYS_WARN ("%s threw an exception", u->name->str);
	LEAVE;
}



/*--------------------------------------------------------------------------*/
static int qu_gtk_signal_boolean (qu_callback x, long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8)
{
	qu_sub  u = x->sub;
	int     argc = u->argc;
	qu_any  argv [MAXARGS], o;
	int     r = 0;

	ENTER;
	qu_gtk_callback_setarg (u, &a1, argc, argv);
	o = qu_sub_calln (u, x->self, argc, argv);
	if (o == 0)
	{
		QU_SYS_WARN ("%s threw an exception", u->name->str);
	}
	else if (qu_boolean_is (o))
	{
		r = (o == (qu_any) QuTrue);
	}
	else
	{
		QU_SYS_WARN ("%s did not return a boolean", u->name->str);
	}
	LEAVE;
	return r;
}



/*--------------------------------------------------------------------------*/
static int qu_gtk_signal_int (qu_callback x, long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8)
{
	qu_sub  u = x->sub;
	int     argc = u->argc;
	qu_any  argv [MAXARGS], o;
	int     r = 0;

	ENTER;
	qu_gtk_callback_setarg (u, &a1, argc, argv);
	o = qu_sub_calln (u, x->self, argc, argv);
	if (o == 0)
	{
		QU_SYS_WARN ("%s threw an exception", u->name->str);
	}
	else
	{
		r = qu_integer_toi (o);
		if (errno)
		{
			QU_SYS_WARN ("%s did not return an int", u->name->str);
			r = 0;
		}
	}
	LEAVE;
	return r;
}



/*--------------------------------------------------------------------------*/
static float qu_gtk_signal_float (qu_callback x, long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8)
{
	qu_sub  u = x->sub;
	int     argc = u->argc;
	qu_any  argv [MAXARGS], o;
	float   r = 0;

	ENTER;
	qu_gtk_callback_setarg (u, &a1, argc, argv);
	o = qu_sub_calln (u, x->self, argc, argv);
	if (o == 0)
	{
		QU_SYS_WARN ("%s threw an exception", u->name->str);
	}
	else
	{
		r = qu_decimal_tof (o);
		if (errno)
		{
			QU_SYS_WARN ("%s did not return a float", u->name->str);
			r = 0;
		}
	}
	LEAVE;
	return r;
}



/*--------------------------------------------------------------------------*/
static double qu_gtk_signal_double (qu_callback x, long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8)
{
	qu_sub  u = x->sub;
	int     argc = u->argc;
	qu_any  argv [MAXARGS], o;
	double  r = 0;

	ENTER;
	qu_gtk_callback_setarg (u, &a1, argc, argv);
	o = qu_sub_calln (u, x->self, argc, argv);
	if (o == 0)
	{
		QU_SYS_WARN ("%s threw an exception", u->name->str);
	}
	else
	{
		r = qu_decimal_tod (o);
		if (errno)
		{
			QU_SYS_WARN ("%s did not return a double", u->name->str);
			r = 0;
		}
	}
	LEAVE;
	return r;
}



/*--------------------------------------------------------------------------*/
/*
	!!! I am assuming that all char * returned value must be Glib allocated

	If this is not the case then we will have to rely on the programmers
	to call g_strdup (or whatever) from Qu.
*/
static char *qu_gtk_signal_string (qu_callback x, long a1, long a2, long a3, long a4, long a5, long a6, long a7, long a8)
{
	qu_sub      u = x->sub;
	int         argc = u->argc;
	qu_any      argv [MAXARGS];
	qu_stringy  o;
	gchar      *r = 0;

	ENTER;
	qu_gtk_callback_setarg (u, &a1, argc, argv);
	o = qu_sub_calln (u, x->self, argc, argv);
	if (o == 0)
	{
		QU_SYS_WARN ("%s threw an exception", u->name->str);
	}
	else if (qu_stringy_is (o))
	{
		r = g_strdup (o->str);
	}
	else
	{
		QU_SYS_WARN ("%s did not return a string", u->name->str);
	}
	LEAVE;
	return r;
}


/*--------------------------------------------------------------------------*/
static void *qu_gtk_signal_getfunc (qu_sub u)
{
	if (u->type == 0)
	{
		return qu_gtk_signal_void;
	}
	else
	{
		switch (qu_struct_type_to_char (u->type))
		{
			case QU_STRUCT_ID_Boolean : return qu_gtk_signal_boolean;
			case QU_STRUCT_ID_int     : return qu_gtk_signal_int;
			case QU_STRUCT_ID_float   : return qu_gtk_signal_float;
			case QU_STRUCT_ID_double  : return qu_gtk_signal_double;
			case QU_STRUCT_ID_String  : return qu_gtk_signal_string;
		}
	}
	QU_FATAL ("never");
	return 0;
}
