/* Netconst.c - Copyright (c) Marc Krisnanto */


/*) const MAXHOSTNAMELEN = 255 # by default
	The maximum length of a hostname.
*/
#ifndef MAXHOSTNAMELEN
#define MAXHOSTNAMELEN 255
#endif


/*) const MAXIPLEN = 46 # by default
	The maximum length of an IP string (the value is set for IPv6).
*/
#ifdef INET6_ADDRSTRLEN
#define MAXIPLEN INET6_ADDRSTRLEN
#else
#define MAXIPLEN 46
#endif


/*) const SOMAXCONN	= 128 # by default
	The Maximum queue length specifiable by listen.
*/
#ifndef SOMAXCONN
#define SOMAXCONN 128
#endif



/*----------------------------------------------------------------------------
	init
----------------------------------------------------------------------------*/

static void _net_init_const (qu_module m)
{
	qu_module_add_const (m, "MAXHOSTNAMELEN", qu_int_newi (MAXHOSTNAMELEN));
	qu_module_add_const (m, "MAXIPLEN"      , qu_int_newi (MAXIPLEN));
	qu_module_add_const (m, "SOMAXCONN"     , qu_int_newi (SOMAXCONN));
}
