/* Function.c - Copyright (c) Marc Krisnanto */

#include "qu.h"


/*) class Function __abstract
	This is the parent class of -{Sub} and -{Method}.
	It is only useful to test whether an object is either a Sub or Method.

	@xmp
		println (Sub is Function)
		println (Method is Function)

		s = 'foo'
		m = Method (s, "trim")
		println (m is Method)
		println (m is Function)

		sub foo
			return 10
		;;
		f = @foo
		println (f is Sub)
		println (f is Function)

	@out
		true
		true
		true
		true
		true
		true
*/
qu_class QuFunctionClass;



/*----------------------------------------------------------------------------
	init
----------------------------------------------------------------------------*/

void qu_function__setup ()
{
	qu_class_setup_base (QuFunctionClass, qu_object_s);
}



void qu_function__init ()
{
	/* finalize declaration */
	qu_class_enddecl (QuFunctionClass);
}
